#include<stdio.h>
#include<string.h>
#include<time.h>

const __int64 HMask=0x123456799ABCDEF0ll;
const __int64 LMask=0x789ABCDEF0123456ll;

__int64 A=0x1111111111111111;
__int64 B=0x1111111111111111;

extern "C" unsigned int AR[4]={0x11111111,0x11111111,0x11111111,0x11111111};
extern "C" unsigned int AM[4]={0xF0123456,0x789ABCDE,0x9ABCDEF0,0x12345679};

extern "C" unsigned char u[256];
unsigned char u[256];
unsigned int r[65536];
extern "C" unsigned int *r1;
unsigned int *r1;

void step1(){
	int m=0x10000;
	__int64 a=A,b=B;
	do{
		unsigned int h=0;
		for(int i=0;i<32;i++){
			__int64 p=(a&HMask)^(b&LMask);
			unsigned int q=(unsigned int)p^(unsigned int)(p>>32);
			q^=(q>>16);
			unsigned int c=u[(q^(q>>8))&255];
			a=(a<<1)|((b>>63)&1);
			b=(b<<1)|c;
			h=(h<<1)|c;
		}
		*r1++=h;
	}while(--m);
	A=a; B=b;
}
extern "C" void step3();

void Init(){
	for(int i=0;i<256;i++){
		int a=(i&0xff)^(i>>8);
		a=(a&0xf)^(a>>4);
		a=(a&3)^(a>>2);
		a=(a&1)^(a>>1);
		u[i]=(unsigned char)a;
	}
}

void main(){
	Init();	

	r1=r; step1();
	printf("%08X %08X %08X %08X\n",r[4],r[5],r[6],r[7]);
	r1=r; step3();
	printf("%08X %08X %08X %08X\n",r[4],r[5],r[6],r[7]);



	int K=128;
	long cl0=clock();	
	for(int i=0;i<K;i++){
		r1=r;
		step1();
	}
	long cl1=clock();
	for(int i=0;i<K;i++){
		r1=r;
		step3();
	}
	long cl3=clock();
	printf("Arr: %ld, asm: %ld\n",cl1-cl0,cl3-cl1);
}
